--

package body Buffers.Mailboxes is

   protected body Mailbox_Type is

      entry Get (Item : out Element_Type) when (Elements_In_Buffer /= 0) is
      begin
         Item             := Box_Store (First);
         First            := First mod Max_Capacity + 1;
         Elements_In_Buffer := Elements_In_Buffer - 1;
      end Get;

      --  -- --

      entry Put (Item : in Element_Type) when (Elements_In_Buffer /= Max_Capacity) is
      begin
         Last             := Last mod Max_Capacity + 1;
         Box_Store (Last) := Item;
         Elements_In_Buffer := Elements_In_Buffer + 1;
      end Put;

   end Mailbox_Type;

end Buffers.Mailboxes;
