--

package body Default_Reusable_Futures is

   protected body Default_Future_Type is

      entry Get (D : out My_Futures.Data_Type) when Valid and Allocated is
      begin
         D         := Data;
         Valid     := False;
         Allocated := False;
      end Get;

      entry Set (D : in My_Futures.Data_Type) when Allocated is
      begin
         Data := D;
         Valid := True;
      end Set;

      entry Cancel when Allocated and Valid is
      begin
         Valid     := False;
         Allocated := False;
      end Cancel;

      entry Allocate when not Allocated is
      begin
         Allocated := True;
         Valid     := False;
      end Allocate;

   end Default_Future_Type;

end Default_Reusable_Futures;
